/** @file  ds1307.h
 *  @brief Gestion RTC DS1307
 */
#ifndef DS1307_H
#define DS1307_H


#define DS1307_ADR 0xD0


enum
{
	JOUR_DIM = 0,		// dimanche
	JOUR_LUN,
	JOUR_MAR,
	JOUR_MER,
	JOUR_JEU,
	JOUR_VEN,
	JOUR_SAM	
};

//---------------------------------------------------------------------------
/** Initialisation RTC avec RAZ secondes
 \param 
 */
//---------------------------------------------------------------------------
void
ds1307_init(void);

//---------------------------------------------------------------------------
/** Reglage de l'heure + date RTC 
 \param 
 */
//---------------------------------------------------------------------------
void
ds1307_set_time(void);

//---------------------------------------------------------------------------
/** Lecture heure + date RTC
 \param 
 */
//---------------------------------------------------------------------------
void
ds1307_get_time(void);


#endif // DS1307_H

