;--------------------------------------------------------
; File Created by SDCC : FreeWare ANSI-C Compiler
; Version 2.6.0 #4309 (Jul 28 2006)
; This file generated Tue Mar 06 19:52:48 2007
;--------------------------------------------------------
; PIC16 port for the Microchip 16-bit core micros
;--------------------------------------------------------
	list	p=18f452

	radix dec

;--------------------------------------------------------
; public variables in this module
;--------------------------------------------------------
	global _i2c_init
	global _i2c_waitForIdle
	global _i2c_start
	global _i2c_repStart
	global _i2c_stop
	global _i2c_read
	global _i2c_write

;--------------------------------------------------------
; extern variables in this module
;--------------------------------------------------------
	extern _PORTAbits
	extern _PORTBbits
	extern _PORTCbits
	extern _PORTDbits
	extern _PORTEbits
	extern _LATAbits
	extern _LATBbits
	extern _LATCbits
	extern _LATDbits
	extern _LATEbits
	extern _TRISAbits
	extern _TRISBbits
	extern _TRISCbits
	extern _TRISDbits
	extern _TRISEbits
	extern _PIE1bits
	extern _PIR1bits
	extern _IPR1bits
	extern _PIE2bits
	extern _PIR2bits
	extern _IPR2bits
	extern _EECON1bits
	extern _RCSTAbits
	extern _TXSTAbits
	extern _T3CONbits
	extern _CCP2CONbits
	extern _CCP1CONbits
	extern _ADCON1bits
	extern _ADCON0bits
	extern _SSPCON2bits
	extern _SSPCON1bits
	extern _SSPSTATbits
	extern _T2CONbits
	extern _T1CONbits
	extern _RCONbits
	extern _WDTCONbits
	extern _LVDCONbits
	extern _OSCCONbits
	extern _T0CONbits
	extern _STATUSbits
	extern _INTCON3bits
	extern _INTCON2bits
	extern _INTCONbits
	extern _STKPTRbits
	extern _PORTA
	extern _PORTB
	extern _PORTC
	extern _PORTD
	extern _PORTE
	extern _LATA
	extern _LATB
	extern _LATC
	extern _LATD
	extern _LATE
	extern _TRISA
	extern _TRISB
	extern _TRISC
	extern _TRISD
	extern _TRISE
	extern _PIE1
	extern _PIR1
	extern _IPR1
	extern _PIE2
	extern _PIR2
	extern _IPR2
	extern _EECON1
	extern _EECON2
	extern _EEDATA
	extern _EEADR
	extern _RCSTA
	extern _TXSTA
	extern _TXREG
	extern _RCREG
	extern _SPBRG
	extern _T3CON
	extern _TMR3L
	extern _TMR3H
	extern _CCP2CON
	extern _CCPR2L
	extern _CCPR2H
	extern _CCP1CON
	extern _CCPR1L
	extern _CCPR1H
	extern _ADCON1
	extern _ADCON0
	extern _ADRESL
	extern _ADRESH
	extern _SSPCON2
	extern _SSPCON1
	extern _SSPSTAT
	extern _SSPADD
	extern _SSPBUF
	extern _T2CON
	extern _PR2
	extern _TMR2
	extern _T1CON
	extern _TMR1L
	extern _TMR1H
	extern _RCON
	extern _WDTCON
	extern _LVDCON
	extern _OSCCON
	extern _T0CON
	extern _TMR0L
	extern _TMR0H
	extern _STATUS
	extern _FSR2L
	extern _FSR2H
	extern _PLUSW2
	extern _PREINC2
	extern _POSTDEC2
	extern _POSTINC2
	extern _INDF2
	extern _BSR
	extern _FSR1L
	extern _FSR1H
	extern _PLUSW1
	extern _PREINC1
	extern _POSTDEC1
	extern _POSTINC1
	extern _INDF1
	extern _WREG
	extern _FSR0L
	extern _FSR0H
	extern _PLUSW0
	extern _PREINC0
	extern _POSTDEC0
	extern _POSTINC0
	extern _INDF0
	extern _INTCON3
	extern _INTCON2
	extern _INTCON
	extern _PRODL
	extern _PRODH
	extern _TABLAT
	extern _TBLPTRL
	extern _TBLPTRH
	extern _TBLPTRU
	extern _PCL
	extern _PCLATH
	extern _PCLATU
	extern _STKPTR
	extern _TOSL
	extern _TOSH
	extern _TOSU
	extern _tx232
	extern _tx232_2ascii
;--------------------------------------------------------
;	Equates to used internal registers
;--------------------------------------------------------
STATUS	equ	0xfd8
WREG	equ	0xfe8
FSR1L	equ	0xfe1
FSR2L	equ	0xfd9
POSTDEC1	equ	0xfe5
PREINC1	equ	0xfe4
PLUSW2	equ	0xfdb
PRODL	equ	0xff3


; Internal registers
.registers	udata_ovr	0x0000
r0x00	res	1
r0x01	res	1

;--------------------------------------------------------
; global & static initialisations
;--------------------------------------------------------
; I code from now on!
; ; Starting pCode block
S_i2c__i2c_write	code
_i2c_write:
;	.line	115; i2c.c	i2c_write( unsigned char i2cWriteData )
	MOVFF	FSR2L, POSTDEC1
	MOVFF	FSR1L, FSR2L
	MOVFF	r0x00, POSTDEC1
	MOVLW	0x02
	MOVFF	PLUSW2, r0x00
;	.line	117; i2c.c	i2c_waitForIdle();
	CALL	_i2c_waitForIdle
;	.line	118; i2c.c	SSPBUF = i2cWriteData;
	MOVFF	r0x00, _SSPBUF
;	.line	121; i2c.c	tx232('W');
	MOVLW	0x57
	MOVWF	POSTDEC1
	CALL	_tx232
	INCF	FSR1L, F
;	.line	122; i2c.c	tx232_2ascii(i2cWriteData);
	MOVF	r0x00, W
	MOVWF	POSTDEC1
	CALL	_tx232_2ascii
	INCF	FSR1L, F
;	.line	125; i2c.c	return ( ! (SSPCON2bits.ACKSTAT)  ); 			// function returns '1' if transmission is acknowledged
	CLRF	r0x00
	BTFSC	_SSPCON2bits, 6
	INCF	r0x00, F
	MOVF	r0x00, W
	BSF	STATUS, 0
	TSTFSZ	WREG
	BCF	STATUS, 0
	CLRF	r0x00
	RLCF	r0x00, F
	MOVF	r0x00, W
	MOVFF	PREINC1, r0x00
	MOVFF	PREINC1, FSR2L
	RETURN	

; ; Starting pCode block
S_i2c__i2c_read	code
_i2c_read:
;	.line	92; i2c.c	i2c_read( unsigned char ack )
	MOVFF	FSR2L, POSTDEC1
	MOVFF	FSR1L, FSR2L
	MOVFF	r0x00, POSTDEC1
	MOVFF	r0x01, POSTDEC1
	MOVLW	0x02
	MOVFF	PLUSW2, r0x00
;	.line	95; i2c.c	i2c_waitForIdle();
	CALL	_i2c_waitForIdle
;	.line	96; i2c.c	SSPCON2bits.RCEN = 1;
	BSF	_SSPCON2bits, 3
;	.line	97; i2c.c	i2c_waitForIdle();
	CALL	_i2c_waitForIdle
;	.line	98; i2c.c	i2cReadData = SSPBUF;
	MOVFF	_SSPBUF, r0x01
;	.line	99; i2c.c	i2c_waitForIdle();
	CALL	_i2c_waitForIdle
;	.line	100; i2c.c	if (ack)	SSPCON2bits.ACKDT = 0;
	MOVF	r0x00, W
	BTFSC	STATUS, 2
	GOTO	_00127_DS_
	BCF	_SSPCON2bits, 5
	GOTO	_00128_DS_
_00127_DS_:
;	.line	101; i2c.c	else		SSPCON2bits.ACKDT = 1;
	BSF	_SSPCON2bits, 5
_00128_DS_:
;	.line	102; i2c.c	SSPCON2bits.ACKEN = 1;               			// send acknowledge sequence
	BSF	_SSPCON2bits, 4
;	.line	105; i2c.c	tx232('R');
	MOVLW	0x52
	MOVWF	POSTDEC1
	CALL	_tx232
	INCF	FSR1L, F
;	.line	106; i2c.c	tx232_2ascii(i2cReadData);
	MOVF	r0x01, W
	MOVWF	POSTDEC1
	CALL	_tx232_2ascii
	INCF	FSR1L, F
;	.line	109; i2c.c	return( i2cReadData );
	CLRF	r0x00
	MOVFF	r0x00, PRODL
	MOVF	r0x01, W
	MOVFF	PREINC1, r0x01
	MOVFF	PREINC1, r0x00
	MOVFF	PREINC1, FSR2L
	RETURN	

; ; Starting pCode block
S_i2c__i2c_stop	code
_i2c_stop:
;	.line	79; i2c.c	i2c_stop(void)
	MOVFF	FSR2L, POSTDEC1
	MOVFF	FSR1L, FSR2L
;	.line	83; i2c.c	tx232('P');
	MOVLW	0x50
	MOVWF	POSTDEC1
	CALL	_tx232
	INCF	FSR1L, F
;	.line	85; i2c.c	i2c_waitForIdle();
	CALL	_i2c_waitForIdle
;	.line	86; i2c.c	SSPCON2bits.PEN = 1;
	BSF	_SSPCON2bits, 2
	MOVFF	PREINC1, FSR2L
	RETURN	

; ; Starting pCode block
S_i2c__i2c_repStart	code
_i2c_repStart:
;	.line	67; i2c.c	i2c_repStart(void) 
	MOVFF	FSR2L, POSTDEC1
	MOVFF	FSR1L, FSR2L
;	.line	70; i2c.c	tx232('R');
	MOVLW	0x52
	MOVWF	POSTDEC1
	CALL	_tx232
	INCF	FSR1L, F
;	.line	72; i2c.c	i2c_waitForIdle();
	CALL	_i2c_waitForIdle
;	.line	73; i2c.c	SSPCON2bits.RSEN = 1;
	BSF	_SSPCON2bits, 1
	MOVFF	PREINC1, FSR2L
	RETURN	

; ; Starting pCode block
S_i2c__i2c_start	code
_i2c_start:
;	.line	54; i2c.c	i2c_start(void) 
	MOVFF	FSR2L, POSTDEC1
	MOVFF	FSR1L, FSR2L
;	.line	57; i2c.c	tx232('S');
	MOVLW	0x53
	MOVWF	POSTDEC1
	CALL	_tx232
	INCF	FSR1L, F
;	.line	60; i2c.c	i2c_waitForIdle();
	CALL	_i2c_waitForIdle
;	.line	61; i2c.c	SSPCON2bits.SEN = 1;
	BSF	_SSPCON2bits, 0
	MOVFF	PREINC1, FSR2L
	RETURN	

; ; Starting pCode block
S_i2c__i2c_waitForIdle	code
_i2c_waitForIdle:
;	.line	39; i2c.c	i2c_waitForIdle(void) 
	MOVFF	FSR2L, POSTDEC1
	MOVFF	FSR1L, FSR2L
	MOVFF	r0x00, POSTDEC1
	MOVFF	r0x01, POSTDEC1
_00109_DS_:
;	.line	42; i2c.c	while (( SSPCON2 & 0x1F ) | SSPSTATbits.R_W) 
	MOVLW	0x1f
	ANDWF	_SSPCON2, W
	MOVWF	r0x00
	CLRF	r0x01
	BTFSC	_SSPSTATbits, 2
	INCF	r0x01, F
	MOVF	r0x01, W
	IORWF	r0x00, F
	MOVF	r0x00, W
	BTFSS	STATUS, 2
	GOTO	_00109_DS_
	MOVFF	PREINC1, r0x01
	MOVFF	PREINC1, r0x00
	MOVFF	PREINC1, FSR2L
	RETURN	

; ; Starting pCode block
S_i2c__i2c_init	code
_i2c_init:
;	.line	11; i2c.c	i2c_init(void) 
	MOVFF	FSR2L, POSTDEC1
	MOVFF	FSR1L, FSR2L
;	.line	16; i2c.c	TRISCbits.TRISC3=1;	
	BSF	_TRISCbits, 3
;	.line	17; i2c.c	TRISCbits.TRISC4=1;	
	BSF	_TRISCbits, 4
;	.line	19; i2c.c	SSPCON1 = 0x38;					// set I2C master mode
	MOVLW	0x38
	MOVWF	_SSPCON1
;	.line	20; i2c.c	SSPCON2 = 0x00;					
	CLRF	_SSPCON2
;	.line	25; i2c.c	SSPADD = ((FOSC/FI2C)-1)/4;
	MOVLW	0x6e
	MOVWF	_SSPADD
;	.line	27; i2c.c	SSPSTATbits.CKE = 0;								// use I2C levels      worked also with '0'
	BCF	_SSPSTATbits, 6
;	.line	28; i2c.c	SSPSTATbits.SMP = 0;								// disable slew rate control  worked also with '0'
	BCF	_SSPSTATbits, 7
	;	VOLATILE READ - BEGIN
	MOVF	_SSPBUF, W
	;	VOLATILE READ - END
;	.line	32; i2c.c	PIR1bits.SSPIF  = 0;								// clear SSPIF interrupt flag 
	BCF	_PIR1bits, 3
;	.line	33; i2c.c	PIR2bits.BCLIF  = 0;								// clear bus collision flag
	BCF	_PIR2bits, 3
	MOVFF	PREINC1, FSR2L
	RETURN	



; Statistics:
; code size:	  362 (0x016a) bytes ( 0.28%)
;           	  181 (0x00b5) words
; udata size:	    0 (0x0000) bytes ( 0.00%)
; access size:	    2 (0x0002) bytes


	end
